// ----- EXAMPLE 1 ----------------------------------------

DataSet ds = new DataSet("MyDataSet");
DataTable dt = new DataTable("MyTable");

// ... code to define the schema for the newly constructed DataTable

ds.Tables.Add(dt);




// ----- EXAMPLE 2 ----------------------------------------

// create two new tables
DataTable dt1 = new DataTable();
DataTable dt2 = new DataTable();

// use the AddRange() method to add them to the DataSet.

ds.Tables.AddRange(new DataTable[] {dt1, dt2});




// ----- EXAMPLE 3 ----------------------------------------

// connection and select command strings
String connString = "Data Source=(local);Integrated security=SSPI;" +
    "Initial Catalog=Northwind;";
String selectSql = "SELECT * FROM Orders";

// create a new DataSet to receive the data
DataSet ds = new DataSet();

SqlDataAdapter da = new sqlDataAdapter(selectSql, connString);
// an empty table named OrdersSchema will be created in the DataSet
da.FillSchema(ds, SchemaType.Mapped, "OrdersSchema");

// a table named Orders will be created in the DataSet
// filled with data as specified by the SQL statement
da.Fill(ds, "Orders");




// ----- EXAMPLE 4 ----------------------------------------

// using the table name
DataTable dt = ds.Tables["MyTable"];

// using the table ordinal
DataTable dt = ds.Tables[0];




// ----- EXAMPLE 5 ----------------------------------------

Int32 tableCount = ds.Tables.Count;




// ----- EXAMPLE 6 ----------------------------------------

// Boolean tableExists = ds.Tables.Contains("MyTable");




// ----- EXAMPLE 7 ----------------------------------------

// get the index using the name of the table
Int32 tableIndex = ds.Tables.IndexOf("MyTable");

// get the index using a reference to a table
DataTable dt = ds.Tables.Add("MyTable")

// ... build the table and do some work

// get the index of the table based on the table reference
Int32 tableIndex = ds.Tables.IndexOf(dt);




// ----- EXAMPLE 8 ----------------------------------------

DataTable dt = ds.Tables.Add("MyTable");

// remove by table reference
ds.Remove(dt);

// remove using the table name
ds.Remove("MyTable");




// ----- EXAMPLE 9 ----------------------------------------

// removes the first table from the tables collection in the DataSet
ds.RemoveAt[0];




// ----- EXAMPLE 10 ---------------------------------------

ds.Tables.Clear();