// ----- EXAMPLE 1 ----------------------------------------

// add a unique constraint by reference
UniqueConstraint uc =
    new UniqueConstraint(dt.Columns["MyColumn"]);
dt.Constraints.Add(uc);

// add a foreign key constraint by reference (wxh  test)
ForeignKeyConstraint fc = new ForeignKeyConstraint(
    dtParent.Columns["ParentColumn"],
    dtChild.Columns["ChildColumn"]);
dt.Constraints.Add(fc);




// ----- EXAMPLE 2 ----------------------------------------

// add a unique constraint that is also a primary key
dt.Constraints.Add("MyUniqueConstraint", dt.Columns["MyColumn"], true);




// ----- EXAMPLE 3 ----------------------------------------

// add a foreign key constraint based on two columns
dt.Constraints.Add("MyForeignKeyConstraint",
    new DataColumn(dtParent.Columns["ParentCol1"],
    new dtParent.Columns["parentCol2"]),
    new DataColumn(dtChild.Columns["ChildCol1"],
    dtChild.Columns["ChildCol2"]));




// ----- EXAMPLE 4 ----------------------------------------

Int32 constraintCount = dt.Constraints.Count;




// ----- EXAMPLE 5 ----------------------------------------

Boolean colExists = dt.Columns.Exists("MyColumn");




// ----- EXAMPLE 6 ----------------------------------------

// remove a constraint by specifying the name of the constraint
dt.Constraints.Remove("MyConstraint");

// remove a constraint by specifying a reference to the constraint
DataConstraint constraint = new DataConstraint("MyConstraint");
dt.Constraints.Add(constraint);

// ... do some work

dt.Constraints.Remove(constraint);




// ----- EXAMPLE 7 ----------------------------------------

// remove the first constraint from the collection
dt.Constraints.RemoveAt(0);




// ----- EXAMPLE 8 ----------------------------------------

dt.Constraints.Clear();