// ----- EXAMPLE 1 ----------------------------------------

DataTable dt = new DataTable("MyTable");
dt.Columns.Add("Column1", typeof(System.Int32));
dt.Columns.Add("Column2", typeof(System.String));

DataRow newrow = dt.NewRow();
newrow["Column1"].Value = 1;
newrow["Column2"].Value = "DataRow 1";

// add a row using a reference to a DataRow
dt.Rows.Add(dr);

// add and create a DataRow in one statement
dt.Rows.Add(new Object[] {2, "DataRow 2"});




// ----- EXAMPLE 2 ----------------------------------------

// create a new row
DataRow row = dt.NewRow();
row.ItemArray = new Object[] {1, "DataRow 1"};

// insert a new row as the first item of the collection
dt.Rows.InsertAt(row, 0);




// ----- EXAMPLE 3 ----------------------------------------

// look for a primary key that is based on a single column
Boolean exists = dt.Rows.Contains("PK Value 1");

// look for a primary key that is based on multiple columns
Boolean exists = dt.Rows.Contains(new Object[] {"PK Field1 Value",
     "PK Field2 Value"});




// ----- EXAMPLE 4 ----------------------------------------

// get the row for a primary key that is based on a single column
DataRow row = dt.Rows.Find("PK Value 1");

// get the row for a primary key that is based on multiple columns
DataRow row = dt.Rows.Find(new Object[] {"PK Field1 Value",
     "PK Field2 Value"});




// ----- EXAMPLE 5 ----------------------------------------

// remove the row matching the primary key value, if found
DataRow row = dt.Rows.Find("PK Value 1");

if(row! = null)
    dt.Rows.Remove(row);




// ----- EXAMPLE 6 ----------------------------------------

// remove the first row from the collection
dt.Rows.RemoveAt(0);




// ----- EXAMPLE 7 ----------------------------------------

// remove all rows from the table
dt.Rows.Clear();