// ----- EXAMPLE 1 ----------------------------------------

// delete the first row from the table
DataRow row = dt.Rows[0];
row.Delete();     // RowState changed to Deleted

row = dt.NewRow();
// ... code to set the data for the row

// add the row to the table
dt.Rows.Add(row);

// delete the row
row.Delete();     // Newly inserted row is removed from the table




// ----- EXAMPLE 2 ----------------------------------------

// Iterate over the results (and ignore deleted rows).
foreach (DataRow dr in ds.Tables["Customers"].Rows)
{
    if (dr.RowState != DataRowState.Deleted)
        {
            // ... process the row
        }
}