// ----- EXAMPLE 1 ----------------------------------------

DataRow row;
// ... code to retrieve data into the row

// access the column by its ordinal and update the value
row[0] = "New Value";

// access the column by its name and update the value
row["MyColumn"] = "New Value";




// ----- EXAMPLE 2 ----------------------------------------

DataTable dt = new DataTable();

// ... code to retrieve data into the DataTable object

DataRow row = dt.Rows[0];

row.BeginEdit();
foreach(DataColumn col in dt.Columns)
{
    // ...modify the column value
}

bool rowValid = true;

// ...check the values in the row to make sure that they are valid

if(rowValid)
{
    row.CancelEdit();
}
else
{
    row.EndEdit();
}




// ----- EXAMPLE 3 ----------------------------------------

// create a table with two columns
DataTable dt = new DataTable();
DataColumn colId =
    new DataColumn("ProductId", typeof(System.Int32));
DataColumn colDesc =
    new DataColumn("Description", typeof(System.String));
dt.Columns.AddRange(new DataColumn[] {colId, colDesc});

dt.Rows.Add(new object[] {1, "Widget"});

// get the data for the row using the ItemArray property
object[] row = dt.Rows[0].ItemArray;

// set the ProductId to be AutoIncrement
colId.AutoIncrement = true;
// pass null for the AutoIncrement value
dt.Rows.Add(new object[] {null, "Thing"});

// let the description be null
colDesc.AllowDBNull = true;
// add a row with a null description, and AutoIncrement Id
dt.Rows.Add(new object[] {null, null});