using System.Data;
using System.Data.SqlClient;
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ADOTest
{
	/// <summary>
	/// Summary description for HierarchicalTreeView.
	/// </summary>
	public class HierarchicalTreeView : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TreeView tree;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public HierarchicalTreeView()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tree = new System.Windows.Forms.TreeView();
			this.SuspendLayout();
			// 
			// tree
			// 
			this.tree.ImageIndex = -1;
			this.tree.Location = new System.Drawing.Point(8, 8);
			this.tree.Name = "tree";
			this.tree.SelectedImageIndex = -1;
			this.tree.Size = new System.Drawing.Size(276, 248);
			this.tree.TabIndex = 0;
			// 
			// HierarchicalTreeView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tree});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "HierarchicalTreeView";
			this.Text = "Hierarchical TreeView";
			this.Load += new System.EventHandler(this.HierarchicalTreeView_Load);
			this.ResumeLayout(false);

		}
		#endregion
		string connectionString = "Data Source=localhost;" +
			"Initial Catalog=Northwind;Integrated Security=SSPI";
		string categorySQL = "SELECT * FROM Categories";
		string productSQL = "SELECT * FROM Products";

		private void HierarchicalTreeView_Load(object sender, System.EventArgs e)
		{
			// Create ADO.NET objects.
			SqlConnection con = new SqlConnection(connectionString);
			SqlCommand com = new SqlCommand(categorySQL, con);
			SqlDataAdapter adapter = new SqlDataAdapter(com);
			DataSet ds = new DataSet();
		
			// Execute the command.
			try
			{
				con.Open();
				adapter.Fill(ds, "Categories");
				adapter.SelectCommand.CommandText = productSQL;
				adapter.Fill(ds, "Products");
			}
			catch (Exception err)
			{
				MessageBox.Show(err.ToString());
			}
			finally
			{
				con.Close();
			}

			// Add the relation.
			DataColumn parentCol = ds.Tables["Categories"].Columns["CategoryID"];
			DataColumn childCol = ds.Tables["Products"].Columns["CategoryID"];
			DataRelation relation = new DataRelation("Cat_Prod", parentCol, childCol);
			ds.Relations.Add(relation);

			// Fill the tree.
			foreach (DataRow parent in ds.Tables["Categories"].Rows)
			{
				TreeNode nodeParent = tree.Nodes.Add(parent["CategoryName"].ToString());
				foreach (DataRow child in parent.GetChildRows(relation))
				{
					nodeParent.Nodes.Add(child["ProductName"].ToString());
				}		
			}
		}

		
		public static void Main()
		{
			Application.Run(new HierarchicalTreeView());
		}
	}
}
