using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace ADOTest
{
	/// <summary>
	/// Summary description for MasterDetail.
	/// </summary>
	public class MasterDetail : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MasterDetail()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lstCategories = new System.Windows.Forms.ListBox();
			this.lstProducts = new System.Windows.Forms.ListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// lstCategories
			// 
			this.lstCategories.Location = new System.Drawing.Point(8, 28);
			this.lstCategories.Name = "lstCategories";
			this.lstCategories.Size = new System.Drawing.Size(140, 225);
			this.lstCategories.TabIndex = 0;
			this.lstCategories.SelectedIndexChanged += new System.EventHandler(this.lstCategories_SelectedIndexChanged);
			// 
			// lstProducts
			// 
			this.lstProducts.Location = new System.Drawing.Point(152, 28);
			this.lstProducts.Name = "lstProducts";
			this.lstProducts.Size = new System.Drawing.Size(252, 225);
			this.lstProducts.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(108, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Category:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(152, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(108, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "Products:";
			// 
			// MasterDetail
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(412, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.label1,
																		  this.lstProducts,
																		  this.lstCategories});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "MasterDetail";
			this.Text = "A Master-Detail Form";
			this.Load += new System.EventHandler(this.MasterDetail_Load);
			this.ResumeLayout(false);

		}
		#endregion

		string connectionString = "Data Source=localhost;" +
			"Initial Catalog=Northwind;Integrated Security=SSPI";
		string categorySQL = "SELECT * FROM Categories";
		string productSQL = "SELECT * FROM Products";

		DataSet ds = new DataSet();
		DataRelation relation;

		private System.Windows.Forms.ListBox lstCategories;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ListBox lstProducts;

		public static void Main()
		{
			Application.Run(new MasterDetail());
		}

		private void MasterDetail_Load(object sender, System.EventArgs e)
		{
			// Create ADO.NET objects.
			SqlConnection con = new SqlConnection(connectionString);
			SqlCommand com = new SqlCommand(categorySQL, con);
			SqlDataAdapter adapter = new SqlDataAdapter(com);
		
			// Execute the command.
			try
			{
				con.Open();
				adapter.Fill(ds, "Categories");
				adapter.SelectCommand.CommandText = productSQL;
				adapter.Fill(ds, "Products");
			}
			catch (Exception err)
			{
				MessageBox.Show(err.ToString());
			}
			finally
			{
				con.Close();
			}

			// Add the relation.
			DataColumn parentCol = ds.Tables["Categories"].Columns["CategoryID"];
			DataColumn childCol = ds.Tables["Products"].Columns["CategoryID"];
			relation = new DataRelation("Cat_Prod", parentCol, childCol);
			ds.Relations.Add(relation);

			// Show the category list.
			foreach (DataRow row in ds.Tables["Categories"].Rows)
			{
				lstCategories.Items.Add(row["CategoryName"]);
			}


		}

		private void lstCategories_SelectedIndexChanged(object sender, System.EventArgs e)
		{
            lstProducts.Items.Clear();

			// Find the corresponding parent row.
			DataRow[] rows = ds.Tables["Categories"].Select("CategoryName='" + lstCategories.Text + "'");
			DataRow parent = rows[0];

			// Browse through all the children.
			foreach (DataRow child in parent.GetChildRows(relation))
			{
				lstProducts.Items.Add(child["ProductName"]);
			}
		}
	}
}
