using System.Data;
using System.Data.SqlClient;
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DataBinding
{
	/// <summary>
	/// Summary description for MasterDetail.
	/// </summary>
	public class MasterDetail : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.DataGrid gridSuppliers;
		private System.Windows.Forms.DataGrid gridProducts;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MasterDetail()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridSuppliers = new System.Windows.Forms.DataGrid();
			this.gridProducts = new System.Windows.Forms.DataGrid();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.gridSuppliers)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridProducts)).BeginInit();
			this.SuspendLayout();
			// 
			// gridSuppliers
			// 
			this.gridSuppliers.AlternatingBackColor = System.Drawing.SystemColors.Window;
			this.gridSuppliers.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridSuppliers.BackgroundColor = System.Drawing.SystemColors.AppWorkspace;
			this.gridSuppliers.CaptionVisible = false;
			this.gridSuppliers.DataMember = "";
			this.gridSuppliers.GridLineColor = System.Drawing.SystemColors.Control;
			this.gridSuppliers.HeaderBackColor = System.Drawing.SystemColors.Control;
			this.gridSuppliers.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.gridSuppliers.LinkColor = System.Drawing.SystemColors.HotTrack;
			this.gridSuppliers.Location = new System.Drawing.Point(8, 28);
			this.gridSuppliers.Name = "gridSuppliers";
			this.gridSuppliers.SelectionBackColor = System.Drawing.SystemColors.ActiveCaption;
			this.gridSuppliers.SelectionForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.gridSuppliers.Size = new System.Drawing.Size(476, 140);
			this.gridSuppliers.TabIndex = 2;
			// 
			// gridProducts
			// 
			this.gridProducts.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridProducts.CaptionVisible = false;
			this.gridProducts.DataMember = "";
			this.gridProducts.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.gridProducts.Location = new System.Drawing.Point(8, 208);
			this.gridProducts.Name = "gridProducts";
			this.gridProducts.Size = new System.Drawing.Size(476, 140);
			this.gridProducts.TabIndex = 3;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(196, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "Suppliers:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 188);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(208, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "Products Offered by Selected Supplier:";
			// 
			// MasterDetail
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(492, 366);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.label1,
																		  this.gridProducts,
																		  this.gridSuppliers});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "MasterDetail";
			this.Text = "MasterDetail";
			this.Load += new System.EventHandler(this.MasterDetail_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridSuppliers)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridProducts)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		DataSet ds = new DataSet("Northwind");			

		private void MasterDetail_Load(object sender, System.EventArgs e)
		{
			string connectionString = @"Data Source=(local);" +
				"Initial Catalog=Northwind;Integrated Security=SSPI";

			string SQL = "SELECT * FROM Products";

			// Create ADO.NET objects.
			SqlConnection con = new SqlConnection(connectionString);
			SqlCommand com = new SqlCommand(SQL, con);
			SqlDataAdapter adapter = new SqlDataAdapter(com);
						
			// Execute the command.
			try
			{
				adapter.Fill(ds, "Products");

				com.CommandText = "SELECT * FROM Suppliers";
				adapter.Fill(ds, "Suppliers");
			}
			catch (Exception err)
			{
				Console.WriteLine(err.ToString());
			}
			finally
			{
				con.Close();
			}

			// Display the results.
			gridSuppliers.DataSource = ds.Tables["Suppliers"].DefaultView;
			gridProducts.DataSource = ds.Tables["Products"].DefaultView;
			
			// Handle the PositionChanged event for the Suppliers table.
			BindingManagerBase currency;
			currency = this.BindingContext[gridSuppliers.DataSource];
			currency.PositionChanged += new EventHandler(Binding_PositionChanged);

		}

		private void Binding_PositionChanged(object sender, System.EventArgs e)
		{
			string filter;
			DataRowView selectedRow;

			// Find the current category row.
			selectedRow = (DataRowView)this.BindingContext[gridSuppliers.DataSource].Current;

			// Create a filter expression using its SupplierID.
			filter = "SupplierID='" + selectedRow["SupplierID"].ToString() + "'";

			// Modify the view onto the product table.
			ds.Tables["Products"].DefaultView.RowFilter = filter;
		}

		[STAThread]
		static void Main() 
		{
			Application.Run(new MasterDetail());
		}

	}
}
