// ----- EXAMPLE 1 ----------------------------------------

SqlDataAdapter da;

// ... code to set up the data adapter

da.FillError += new FillErrorEventHandler(da_FillError);
DataSet ds = new DataSet();
da.Fill(ds, "MyTable");

private void da_FillError(object sender, FillErrorEventArgs e)
{
    // ... code to identify and correct the error

    // add the fixed row to the table
        DataRow dr = e.DataTable.Rows.Add(new object[] {e.Values[0],
        e.Values[1], e.Values[2]});

    // continue the Fill with the rows remaining in the data source
    e.Continue = true;
}




// ----- EXAMPLE 2 ----------------------------------------

SqlDataAdapter da;

// ... code to set up the data adapter

// add the event handlers
da.RowUpdating += new SqlRowUpdatingEventHandler(da_RowUpdating);
da.RowUpdated += new SqlRowUpdatedEventHandler(da_RowUpdated);

DataSet ds = new DataSet();

// ... code to fill the DataSet
// ... code to modify the data in the DataSet

da.Update(ds, "Orders");

private void da_RowUpdating(object sender, SqlRowUpdatingEventArgs e)
{
    // Write the date, OrderID, and type of update to a log
    System.IO.TextWriter tw = System.IO.File.AppendText("update.log");
    tw.WriteLine("{0}: Order {1} {2}.", DateTime.Now, e.Row["OrderID",
        DataRowVersion.Original], e.StatementType.ToString());
    tw.Close();
}

private void da_RowUpdated(object sender, SqlRowUpdatedEventArgs e)
{
    if(e.Status == UpdateStatus.ErrorsOccurred)
    {
        // set the error information for the row
        e.Row.RowError = e.Errors.Message;
        // skip peocessing the current row and continue with the rest
        e.Status = UpdateStatus.SkipCurrentRow;
    }
}