// ----- EXAMPLE 15.6 -------------------------------------

// Client code

MyWebService ws = new MyWebService();

DataSet ds = new DataSet();
ds = ws.GetData();

// ... code to modify the data in the DataSet

// create the DataSet of changes
DataSet dsChanges = ds.GetChanges();

// update the DataSet to the client and store the returned DataSet
dsChanges = ws.UpdateData(dsChanges);

// primary key OrderID is AutoIncrement. Delete the inserted rows from the
// original DataSet to prevent duplicate rows due to the OrderID changing
// to the data source generated value
foreach(DataRow row in ds.Tables("Orders").Select("", "",
    DataRowViewState.Added)
{
    ds.Tables("Orders").Remove(row);
}

// merge the returned DataSet back into the original changed DataSet
ds.Merge(dsChanges);
ds.AcceptChanges();




// ----- EXAMPLE 15.7 -------------------------------------

// Web Service MyWebService

// connection and select command strings
String connString = "Data Source=(local);Integrated security=SSPI;" +
    "Initial Catalog=Northwind;";
String sqlSelect = "SELECT * FROM Orders";

// create a new DataSet to receive the data
DataSet ds = new DataSet();

SqlDataAdapter da = new sqlDataAdapter(sqlSelect, connString);

// create the command builder
SqlCommandBuilder cb = new SqlCommandBuilder(da);

// read all of the data from the orders table and load it into the
// Orders table in the DataSet
da.Fill(ds, "Orders");

public DataSet GetData()
{
    return ds;
}

public DataSet UpdateData(DataSet dsWS)
{
    // update the changed data from the client to the data source
    da.Update(dsWS, "Orders");

    // return the updated DataSet to the client
    return dsWS;
}