using System;
using System.Data;
using System.Data.SqlClient;
using System.Xml;
using System.IO;

public class XPathSearch
{
    private static string connectionString = "Data Source=localhost;" +
         "Initial Catalog=Northwind;Integrated Security=SSPI";

    public static void Main() 
    {
        string SQL = "SELECT CategoryID, CategoryName, Description " +
                     "FROM Categories";

        // Create ADO.NET objects.
        SqlConnection con = new SqlConnection(connectionString);
        SqlCommand com = new SqlCommand(SQL, con);
        SqlDataAdapter adapter = new SqlDataAdapter(com);
        DataSet ds = new DataSet("Northwind");

        // Execute the command.
        try
        {
            con.Open();
            adapter.FillSchema(ds, SchemaType.Mapped, "Categories");
            adapter.Fill(ds, "Categories");
        }
        catch (Exception err)
        {
            Console.WriteLine(err.ToString());
        }
        finally
        {
            con.Close();
        }

        // Create the XML data document interface.
        XmlDataDocument dataDoc = new XmlDataDocument(ds);

        // Perform search for all Categories that have a
        // CategoryName which starts with "C".
        string XPath;
        XPath = @"//Categories[starts-with(child::CategoryName, 'C')]";
        XmlNodeList nodes = dataDoc.DocumentElement.SelectNodes(XPath);

        foreach (XmlNode node in nodes)
        {
            Console.Write("\nMatch: ");

            foreach (XmlNode child in node.ChildNodes)
            {
                Console.WriteLine(child.InnerText);
            }
         }

    }

}
