using System;
using System.Data;
using System.Data.SqlClient;

public class XmlRelations
{
    private static string connectionString = "Data Source=localhost;" +
         "Initial Catalog=Northwind;Integrated Security=SSPI";

    private static string categorySQL = "SELECT CategoryID, CategoryName, " +
                         "Description FROM Categories";

    private static string productSQL = "SELECT ProductID, ProductName, " +
                        "CategoryID FROM Products";


    public static void Main() 
    {
        // Create ADO.NET objects.
        SqlConnection con = new SqlConnection(connectionString);
        SqlCommand com = new SqlCommand(categorySQL, con);
        SqlDataAdapter adapter = new SqlDataAdapter(com);
        DataSet ds = new DataSet("Nortwind");

        // Execute the command.
        try
        {
            con.Open();
            adapter.FillSchema(ds, SchemaType.Mapped, "Categories");
            adapter.Fill(ds, "Categories");
            adapter.SelectCommand.CommandText = productSQL;
            adapter.FillSchema(ds, SchemaType.Mapped, "Products");
            adapter.Fill(ds, "Products");
        }
        catch (Exception err)
        {
            Console.WriteLine(err.ToString());
        }
        finally
        {
            con.Close();
        }

        // Add the relation.
        DataColumn parentCol = ds.Tables["Categories"].Columns["CategoryID"];
        DataColumn childCol = ds.Tables["Products"].Columns["CategoryID"];
        DataRelation relation = new DataRelation("Cat_Prod", parentCol, childCol);
        ds.Relations.Add(relation);

        // Configure the nested columns.
        relation.Nested = true;

        // Save DataSet to disk.
        ds.WriteXml("mydata.xml");

        // Display the DataSet.
        ds.WriteXml(Console.Out);

    }
}
