// ----- EXAMPLE 1 ----------------------------------------

DataRelation dr = new DataRelation("MyDataRelation",
    parentTable.Columns["PrimaryKeyField"],
    childTable.Columns["ForeignKeyField"]);
ds.Relations.Add(dr);




// ----- EXAMPLE 2 ----------------------------------------

DataTable dt1;
DataColumn col1, col2;
// ... code to define columns col1 and col2 and add them to the table dt1

DataTable dt2;
DataColumn col3, col4;
// ... code to define columns col3 and col4 and add them to the table dt2

DataSet ds = new DataSet();
ds.Tables.Add(dt1);
ds.Tables.Add(dt2);

// add a relation to the DataRelationCollection called MyRelation
// and create the ForeignKey constraint between parent col1 and child col3
ds.Relations.Add("MyRelation", col1, col3, true);

// add the relation between parent columns col1 and col2 and child columns
// col3 and col4. Do not create the ForeignKey constraint.
ds.Relations.Add("MyRelation", new DataColumn[] {col1, col2},
    new DataColumn[] {col3, col4}, false);




// ----- EXAMPLE 3 ----------------------------------------

// code to create DataRelations dr1 and dr2
ds.Relations.AddRange(new DataRelation[] {dr1, dr2});




// ----- EXAMPLE 4 ----------------------------------------

Int32 index = ds.Relations.IndexOf("MyDataRelation");

Int32 index = ds.Relations.IndexOf(dr);




// ----- EXAMPLE 5 ----------------------------------------

// remove the relation names MyDataRelation from the
// DataRelationCollection for the DataSet
ds.Relations.Remove("MyDataRelation");

// remove the first relation in the DataRelationCollection for the DataSet
ds.Relations.RemoveAt(0);




// ----- EXAMPLE 6 ----------------------------------------

ds.Relations.Clear();