// ----- EXAMPLE 1 ----------------------------------------

DataSet ds = new DataSet("MyDataSet");
DataTable dt = new DataTable("MyTable");

// ... code to define the schema for the newly constructed DataTable

ds.Tables.Add(dt);




// ----- EXAMPLE 2 ----------------------------------------

DataSet ds = new DataSet("MyDataSet");
DataTable dt = ds.Tables.Add("MyTable");

// ... code to define the schema for newly constructed DataTable




// ----- EXAMPLE 3 ----------------------------------------

// using the table name
DataTable dt = ds.Tables("MyTable");

// using the table ordinal
DataTable dt = ds.Tables[0];




// ----- EXAMPLE 4 ----------------------------------------

Int32 tableCount = ds.Tables.Count;




// ----- EXAMPLE 5 ----------------------------------------

bool tableExists = ds.Tables.Contains("MyTable");




// ----- EXAMPLE 6 ----------------------------------------

// using the table name
DataTable dt = ds.Tables["MyTable"];

// access the first table in the collection using the table ordinal
DataTable dt = ds.Tables[0];




// ----- EXAMPLE 7 ----------------------------------------

// get the index using the name of the table
Int32 tableIndex = ds.Tables.IndexOf("MyTable");

// get the index using a reference to a table
DataTable dt = ds.Tables.Add("MyTable");

// ... build the table and do some work

// get the index of the table based on the table reference
Int32 tableIndex = ds.Tables.IndexOf(dt);




// ----- EXAMPLE 8 ----------------------------------------

// create two new tables
DataTable dt1 = new DataTable();
DataTable dt2 = new DataTable();

// use the AddRange method to add them to the DataSet.
ds.Tables.AddRange(new DataTable[] {dt1, dt2});




// ----- EXAMPLE 9 ----------------------------------------

DataTable dt = ds.Tables.Add("MyTable");

// remove by table reference
ds.Tables.Remove(dt);

// remove using the table name
ds.Tables.Remove("MyTable");




// ----- EXAMPLE 10 ---------------------------------------

// removes the first table from the tables collection in the DataSet
ds.Tables.RemoveAt(0);




// ----- EXAMPLE 11 ---------------------------------------

ds.Tables.Clear();