// ----- EXAMPLE 1 ----------------------------------------

// adding a column using a reference to an existing column
DataColumn col = new DataColumn("MyColumn", typeof(System.Int32));
dt.Columns.Add(col);

// adding and creating a column in the same statement
dt.Columns.Add("MyColumn", typeof(System.Int32));




// ----- EXAMPLE 2 ----------------------------------------

DataTable dt = new DataTable("MyTable");

// create and add two columns to the DataColumn array
DataColumn[] dca = new DataColumn[]
    {new DataColumn("Col1", typeof(System.Int32)),
    new DataColumn("Col2", typeof(System.Int32))};

// add the columns in the array to the table
dt.Columns.AddRange(dca);




// ----- EXAMPLE 3 ----------------------------------------

Int32 colCount = dt.Columns.Count;




// ----- EXAMPLE 4 ----------------------------------------

bool colExists = dt.Columns.Contains("MyColumn");




// ----- EXAMPLE 5 ----------------------------------------

Int32 colIndex = dt.Columns.IndexOf("MyColumn");




// ----- EXAMPLE 6 ----------------------------------------

// remove a column by specifying the name of the column
dt.Columns.Remove("MyColumn");

// remove a column by specifying a reference to the column
DataColumn col = new DataColumn("MyColumn");
dt.Columns.Add(col);

// ... do some work

dt.Columns.Remove(col);




// ----- EXAMPLE 7 ----------------------------------------

// remove the first column from the collection
dt.Columns.RemoveAt(0);




// ----- EXAMPLE 8 ----------------------------------------

dt.Columns.Clear();




// ----- EXAMPLE 9 ----------------------------------------
dt.Columns.CollectionChanged += new CollectionChangeEventHandler
    (dtColumns_CollectionChanged);

private void dtColumns_CollectionChanged(object sender,
CollectionChangeEventArgs e)
{
    MessageBox.Show("Action = " + e.Action + Environment.NewLine +
        "Element = " + ((DataColumn) e.Element).ColumnName);
}